﻿/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */
import org.flowlib.AbstractScrollBar;
import org.flowplayer.ClipDescriptor;
import org.flowlib.NewAbstractMovieClip;
/**
 * @author anssi
 */
class org.flowlib.HorizontalScrollBar extends AbstractScrollBar {
	
	
	private function getHandleDescriptor():ClipDescriptor {
		return new ClipDescriptor("XScrollHandle", "btnScroll", null);
	}
	
	private function getUpButtonDescriptor():ClipDescriptor {
		return new ClipDescriptor("LeftButton", "btnUpScroll");
	}
	
	private function getDownButtonDescriptor():ClipDescriptor {
		return new ClipDescriptor("RightButton", "btnDownScroll");
	}
	
	private function setLength(clip:MovieClip, length:Number):Void {
		if (clip instanceof NewAbstractMovieClip)
			clip.width = length;
		else
			clip._width = length;
	}
	
	private function getLength(clip:MovieClip):Number {
		if (clip instanceof NewAbstractMovieClip)
			return clip.width;
		return clip._width;
	}
	
	private function getPos(clip:MovieClip):Number {
		return clip._x;
	}
	
	private function setPos(clip:MovieClip, pos:Number):Void {
		clip._x = pos;
	}
	
	private function setFixedLength():Void {
		__height = btnUpScroll._height;
	}
		
	private function getMousePosition() : Number {
		return _xmouse;
	}
	
}