﻿/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */
import org.flowplayer.playlist.PlayList;
import org.flowplayer.playlist.Clip;
import org.flowplayer.skin.Skin;

/**
 * AppContext is used to lookup things like configuration settings.
 */
interface org.flowplayer.config.Config {
	
	public function stringify():String;
 
  	public function getConfigFileName():String;
  	
  	public function setConfigFileName(fileName:String):Void;

	public function getRtmpConfigUrl():String;

	public function getRtmpConfigParam():Object;
		
	public function getBaseURL():String;
	
	public function setBaseURL(baseURL:String):Void;
	
	public function isAutoBuffering():Boolean;
	
	public function isAutoPlay():Boolean;
 	
	public function isAutoRewind() : Boolean;
 	
 	public function isLooping():Boolean;
 	
 	public function getStartingBufferLength():Number;
 	
 	public function getMainBufferLength():Number;
 	
 	public function getVideoHeight():Number;
 	
 	public function showControls():Boolean;
 	
 	public function showPlayListButtons():Boolean;
	
	public function showFullScreenButton():Boolean;
	
	public function showStopButton():Boolean;
	
	public function showPlayButton():Boolean;
	
	public function showMenu():Boolean;
	
	public function showVolumeSlider():Boolean;
	
	public function showMuteVolumeButton():Boolean;
 	
	public function showScrubber():Boolean;
 	
 	public function getSkin(rootConfig:Config):Skin;
 	
 	public function getSkinImagesBaseURL():String;
  	
 	public function getSplashImageFile();

	public function useEmbeddedButtonImages():Boolean;
 	
 	public function getPlayList(baseURL:String):PlayList;
 	
 	public function setPlayList(playList:PlayList):Void;

 	public function thumbsOnFLV():Boolean;
 
 	public function getThumbnails() : Array;
 	
 	public function getStreamingServerURL():String;

 	public function getStreamingServer():String;
 
 	public function useConfigInject():Boolean;

	public function getVideoFile(useBaseUrl:Boolean):String;

	public function getNoVideoClip():Clip;
	
	public function getInitialMediaSize():Number;
	
	public function setIninitalMediaSize(newSize:Number):Void;
	
	public function getProtectionFileName():String;	
	
	/*
	 * Stuff related to skinning.
	 * TODO: Move these to a separate SkinConfig class?
	 */
 	public function getProgressIndicatorColor1():Number;
 	
 	public function getProgressIndicatorColor2():Number;
 	
 	public function getBufferIndicatorColor1():Number;
 	
 	public function getBufferIndicatorColor2():Number;
 	
 	public function getProgressBarBorderColor1():Number;
 	
 	public function getProgressBarBorderColor2():Number;
	
	public function getBufferingAnimationColor():Number;

	public function getControlBarBackgroundColor():Number;
	
	public function getControlBarGloss():String;
	
	public function getTimeDisplayFontColor():Number;

	public function getProgressBarHeight():Number;

	public function getProgressBarAreaHeight():Number;
	
	public function showMenuItem(itemNumber:Number):Boolean;

	public function controlsOverVideo(isFullScreen:Boolean):Boolean;
	
	public function lockControls():Boolean;

	/*
	 */
	
	public function getFullScreenScriptURL():String;
	
	public function useFlashNativeFullScreen():Boolean;
	
	public function useHwScaling():Boolean;
	
 	public function getControlsWidth():Number;

	public function setControlsWidth(newWidth:Number):Void;

	public function isFullScreen():Boolean;

	public function setFullScreen(fullScreen:Boolean):Void;

	public function getEmbedWidth():Number;
	
	public function getEmbedHeight():Number;

	public function setEmbedWidth(width:Number):Void;
	
	public function setEmbedHeight(width:Number):Void;
	
	public function setIsEmbedded(embedded:Boolean):Void;
	
	public function isEmbedded():Boolean;

	public function getProperty(propertyName:String):Object;

	public function useSmoothing():Boolean;
	
	public function getGoogleAnalyticsPrefix():String;
	
	public function getEmbedCode():String;
	
	public function enableAds():Boolean;

	public function getAdServerUrl():String;

	public function getAdServerAuth():String;

	public function getPublisherId():String;

	public function getCountryCode():String;

	public function getEmailPostUrl():String;

	public function getVideoLink():String;

	public function getEmailVideoLink():String;
	
	public function getEmailDefaultMessage():String;
	
	public function usePlayOverlay():Boolean;
	
	public function getWatermarkUrl():String;
	
	public function showWatermark():String;
	
	public function getWatermarkLinkUrl():String;
}
