import org.flowlib.Observable;
import org.flowplayer.image.ImageView;
import org.flowplayer.MediaContext;
import org.flowplayer.MediaControl;
import org.flowplayer.PlaybackStatus;
import org.flowplayer.playlist.PlayList;
import org.flowplayer.AbstractDurationTrackingMediaControl;

import LuminicBox.Log.ConsolePublisher;
import LuminicBox.Log.Logger;
import org.flowplayer.playlist.Clip;
import org.flowplayer.image.LayeredImagesView;
import org.flowplayer.skin.Skin;
import org.flowplayer.image.ResizableView;
import org.flowplayer.MediaView;

/**
 * @author anssi
 */
class org.flowplayer.image.ImageControl extends AbstractDurationTrackingMediaControl implements MediaControl {

	private var imageView:LayeredImagesView;
	private var skin:Skin;
		
	public function ImageControl(skin:Skin) {
		super();
		this.skin = skin;
	}
	
	public function attachView(mcImageView:LayeredImagesView, mediaType:String):Void {
		imageView = mcImageView;
		imageView.addLoadListener(this);
	}

	private function onStartBuffering(clip:Clip):Void {
		var overlayFile:String = clip.getOverlayFileName();
		if (overlayFile) {
			imageView.load(overlayFile, false, clip.getURL(), clip.allowResize());
		} else if (clip.getURL()) {
			imageView.load(undefined, false, clip.getURL(), clip.allowResize());
			showOverLayClip();
		} else {
			imageView.hideUnderImage();
			showOverLayClip();
			onLoaded();
		}
	}
	public function resume():Void {
		imageView.topViewClicked();
		super.resume();
	}
	
	private function showOverLayClip():Void {
		var overlayClip:ResizableView = skin.getOverlayClip(imageView, clip.getOverlayId());
		if (overlayClip) {
			imageView.setTopClip(overlayClip);
		}
	}
	
	public function onLoaded():Void {
		dispatchEventWithObj("onLoadBegin", clip);
		dispatchEventWithObj("onBufferFull", this);
	}

	public function setSound(sound : Sound) : Void {
	}


	public function setViewVisibility():Boolean {
		return false;
	}

	public function allowCenterViewOnLoadBegin():Boolean {
		return false;
	}
	
	public function rewind():Void {
	}
}