﻿/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */
import asunit.framework.TestCase;
import org.flowplayer.FLVController;

class org.flowplayer.FLVControllerTest extends TestCase {

	private var controller:FLVController = new FLVController();

	public function setUp() {
	}

	public function testParseCuePoints() {
		var cuePoints:Array = new Array();
		var point:Object;

		cuePoints[0] = cuePoint("Chapter 10", 9000, 10, "thumb10.jpg");
		cuePoints[1] = cuePoint("Chapter 3", 3000, 3, "thumb3.jpg");
		cuePoints[2] = cuePoint("Chapter 1", 1000, 1, "thumb1.jpg");
		cuePoints[3] = cuePoint("Chapter 4", 4000, 4, "thumb4.jpg");
		cuePoints[4] = cuePoint("Chapter 2", 2000, 2, "thumb2.jpg");
		
		var thumbnails:Array = controller.parseCuePoints("", cuePoints);
		
		assertEquals("wrong order in " + thumbnails, 0, thumbnails[0].pos);
		assertEquals("wrong order in " + thumbnails, 1, thumbnails[1].pos);
		assertEquals("wrong order in " + thumbnails, 2, thumbnails[2].pos);
		assertEquals("wrong order in " + thumbnails, 3, thumbnails[3].pos);
		assertEquals("wrong order in " + thumbnails, 4, thumbnails[4].pos);
	}
	
	
	private function cuePoint(name:String, timestamp:Number, index:Number, thumb:String):Object {
		var point:Object = new Object();
		point.name = name;
		point.time = timestamp;
		point.type = "navigation";
		point.parameters = new Object();
		point.parameters.index = index;
		point.parameters.thumb = thumb;
		return point;
	}
}