/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */
import org.flowplayer.ads.InVideoAd;
import org.flowplayer.ads.InVideoAdController;
import org.flowplayer.ads.InVideoAdView;
import org.flowplayer.config.HierarchicalConfig;
import org.flowplayer.playlist.Clip;
import org.flowplayer.skin.Skin;

import asunit.framework.TestCase;

import LuminicBox.Log.ConsolePublisher;
import org.flowplayer.ads.AdServerClient;
import LuminicBox.Log.Logger;

class org.flowplayer.ads.AdServerClientIntegrationTest extends TestCase {
	
	private var adServerUrl:String = "http://piimaa.info/flowplayer/api";
	private var adServerAuth:String = "foo";
	private var client : AdServerClient;
	private var clip : Clip;
	private var ad : InVideoAd;
	private var logger:Logger;

	public function setUp():Void {
		logger = new Logger();
		logger.addPublisher(new ConsolePublisher());
		var config:HierarchicalConfig = new HierarchicalConfig("{ adServerUrl: '"+adServerUrl+"', adServerAuth: '"+adServerAuth+"', countryCode: 'fi' }", "test config");
		client = new AdServerClient(config);
		client.addAdsLoaderListener(this);
		clip = Clip.createFromObject("http://flowplayer.org", { url: 'coolstuff.flv', duration: 120 });
		ad = new InVideoAd(1, "http://flowplayer.org", "http://flowplayer.org", "http://flowplayer.org/images/smallenso.png", "Title", "Body", "Body2", 3, 10);
	}
		
	public function AdServerClientIntegrationTest(testMethod : String) {
		super(testMethod);
	}
	
	public function testSendClickEvent():Void {
		client.sendClickEventFor(clip, ad);
	}
	
	public function testSendImpressionEvent():Void {
		client.sendImpressionEventFor(clip, ad);
	}
	
	public function testLoadAdsFor():Void {
		client.loadAdsFor(clip);
	}

	public function onAdsLoaded(adsObj:Object):Void {
		logger.debug("received ads");
		logger.debug(adsObj.ads);
	}
}