/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */
import org.flowplayer.ads.InVideoAdView;

import asunit.framework.TestCase;

import LuminicBox.Log.ConsolePublisher;
import LuminicBox.Log.Logger;
import org.flowplayer.ads.InVideoAd;
import org.flowplayer.skin.Skin;

/**
 * @author Anssi
 */
class org.flowplayer.ads.InVideoAdViewTest extends TestCase {
	
	private var view:InVideoAdView;
	private var logger:Logger;
		
	public function setUp():Void {
		view = InVideoAdView(attachMovie("InVideoAdView"));
		view.mySkin = Skin.create(null, null, null, "gray");
		logger = new Logger();
		logger.addPublisher(new ConsolePublisher());
		view.setSize(300, 70);
		view._x = 100;
		view._y = 100;
	}
	
	public function InVideoAdViewTest(testMethod:String) {
		super(testMethod);
	}
	
	public function testSetAd():Void {
		var ad:InVideoAd = new InVideoAd(10, "http://flowplayer.org/adserver", "http://flowplayer.org", 
		"fplogo.png", "In-Video Advertising", "Advertise here!", "In-video advertising by flowplayer.", 10);
		view.setAd(ad);
	}

}