import asunit.framework.TestCase;
import org.flowplayer.audio.MP3Controller;
import org.flowplayer.playlist.Clip;
import LuminicBox.Log.Logger;
import LuminicBox.Log.ConsolePublisher;

/**
 * @author Anssi
 */
class org.flowplayer.audio.MP3ControllerTest extends TestCase {

	private var controller:MP3Controller;
	private var logger:Logger;
	private var resumeInterval:Number;
	
	public function MP3ControllerTest(testMethod:String) {
		super(testMethod);
		logger = new Logger();
		logger.addPublisher(new ConsolePublisher());
		controller = new MP3Controller();
		var sound:Sound = new Sound();
		sound.setVolume(100);
		controller.setSound(sound);
		
		doPause.controller = controller;
		resume.controller = controller;
	}
	
	public function testPlay():Void {
		var clip:Clip = Clip.createSimple("http://flowplayer.org/audio", "02-a_servant.mp3");
		controller.play(clip);
		
		doPause.pauseInterval = setInterval(doPause, 10000);
		this.resumeInterval = setInterval(resume, 20000);
	}

	public function doPause(controller:MP3Controller):Void {
		arguments.callee.controller.pause();
		clearInterval(arguments.callee.pauseInterval);
	};

	public function resume(controller:MP3Controller):Void {
		arguments.callee.controller.resume();
	};
}