/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */
import org.flowplayer.playlist.Clip;
import asunit.framework.TestCase;

class org.flowplayer.playlist.ClipTest extends TestCase {

	private var baseUrl:String;
	private var fileName:String;
	
	public function setUp():Void {
		baseUrl = "http://www.videos.org";
		fileName = "mov.flv";
	}
	
	public function testGetUrl():Void {
		var clip:Clip = Clip.createSimple(baseUrl, "clip1", fileName);
		assertEquals(baseUrl + "/" + fileName, clip.getURL());
	}
	
	public function testGetUrlWithProtectionCode():Void {
		var clip:Clip = Clip.createSimple(baseUrl, "clip1", fileName);
		var code:String = "dsajflkajsf91204395";
		assertEquals(baseUrl + "/" + code + fileName, clip.getURL(code));
	}
	
	public function testGetUrlWithProtectionCodeWhenFileNameHasCompleteURL():Void {
		var clip:Clip = Clip.createSimple(baseUrl, "clip1", baseUrl + "/" + fileName);
		var code:String = "dsajflkajsf91204395";
		assertEquals(clip.getURL(code), baseUrl + "/" + code + fileName, clip.getURL(code));
	}
}