/*    
 *    Copyright 2008 Anssi Piirainen
 *
 *    This file is part of FlowPlayer.
 *
 *    FlowPlayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Foobar is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with FlowPlayer.  If not, see <http://www.gnu.org/licenses/>.
 */
import asunit.framework.TestCase;
import org.flowplayer.thumbs.ViewPortThumbStrip;
import org.flowplayer.thumbs.Thumbnail;
import org.flowplayer.thumbs.SuggestionView;
import org.flowplayer.playlist.Clip;

/**
 * @author Anssi
 */
class org.flowplayer.thumbs.SuggestionViewTest extends TestCase {

	private var strip:SuggestionView;
	
	public function SuggestionViewTest(testMethod:String) {
		super(testMethod);
	}
	
	public function setUp():Void {
		strip = SuggestionView(attachMovie("SuggestionView"));
		strip.setSize(450, 340);
	}
	
	public function testSetThumbnails():Void {
		var clip:Clip = Clip.createSimpleWithThumbAndInfo("http://flowplayer.sourceforge.net/video", "video1.flv", "Video 1", "Thumb1.jpg", { views: 666, category: 'funny' }, 1000);
		var baseUrl:String = "http://flowplayer.sourceforge.net/video";
		strip.setClips([
			Clip.createSimpleWithThumbAndInfo(baseUrl, "video1.flv", "Video 1", "Thumb1.jpg", { views: 166, category: 'funny' }, 1000),
			Clip.createSimpleWithThumbAndInfo(baseUrl, "video2.flv", "Video 2", "Thumb2.jpg", { views: 667, category: 'sports' }, 1800),
			Clip.createSimpleWithThumbAndInfo(baseUrl, "video3.flv", "Video 3", "Thumb3.jpg", { views: 968, category: 'humor' }, 1700)
		]);
	}

}